package com.ruoyi.szxc.service.impl;

import com.ruoyi.common.annotation.DataScope;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.szxc.domain.SzxcJmInfo;
import com.ruoyi.szxc.mapper.SzxcJmInfoMapper;
import com.ruoyi.szxc.service.ISzxcJmInfoService;
import com.ruoyi.szxc.util.GetAgeByBirthdayUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 居民信息Service业务层处理
 * 
 * @author hs
 * @date 2024-03-16
 */
@Service
public class SzxcJmInfoServiceImpl implements ISzxcJmInfoService 
{
    @Resource
    private SzxcJmInfoMapper szxcJmInfoMapper;

    /**
     * 查询居民信息
     * 
     * @param id 居民信息主键
     * @return 居民信息
     */
    @Override
    public SzxcJmInfo selectSzxcJmInfoById(Long id)
    {
        SzxcJmInfo jmInfo = szxcJmInfoMapper.selectSzxcJmInfoById(id);
        Date bornDate = jmInfo.getBornDate();
        int ageByBirth = GetAgeByBirthdayUtil.getAgeByBirth(bornDate);
        jmInfo.setAge(ageByBirth);
        return jmInfo;
    }

    /**
     * 查询居民信息列表
     * 
     * @param szxcJmInfo 居民信息
     * @return 居民信息
     */
    @Override
    @DataScope(deptAlias = "j")
    public List<SzxcJmInfo> selectSzxcJmInfoList(SzxcJmInfo szxcJmInfo)
    {
        List<SzxcJmInfo> szxcJmInfos = szxcJmInfoMapper.selectSzxcJmInfoList(szxcJmInfo);
        //按出生年月计算出年龄
       szxcJmInfos.forEach(info->{
           Date bornDate = info.getBornDate();
           int ageByBirth = GetAgeByBirthdayUtil.getAgeByBirth(bornDate);
           info.setAge(ageByBirth);
       });
        return szxcJmInfos;
    }

    /**
     * 新增居民信息
     * 
     * @param szxcJmInfo 居民信息
     * @return 结果
     */
    @Override
    public AjaxResult insertSzxcJmInfo(SzxcJmInfo szxcJmInfo)
    {
        //身份证号重复验证
        SzxcJmInfo hj = new SzxcJmInfo();
        hj.setCardId(szxcJmInfo.getCardId());
        List<SzxcJmInfo> szxcJmInfos = szxcJmInfoMapper.selectSzxcJmInfoList(hj);
        if(szxcJmInfos!=null&&szxcJmInfos.size()>0){
            return AjaxResult.error("身份证号已存在");
        }
        szxcJmInfo.setCreateTime(DateUtils.getNowDate());
        int result = szxcJmInfoMapper.insertSzxcJmInfo(szxcJmInfo);
        if(result>0){
            return AjaxResult.success();
        }
        return AjaxResult.error();
    }

    /**
     * 修改居民信息
     * 
     * @param szxcJmInfo 居民信息
     * @return 结果
     */
    @Override
    public AjaxResult updateSzxcJmInfo(SzxcJmInfo szxcJmInfo)
    {
        //身份证号重复验证
        SzxcJmInfo hj = new SzxcJmInfo();
        hj.setCardId(szxcJmInfo.getCardId());
        List<SzxcJmInfo> szxcJmInfos = szxcJmInfoMapper.selectSzxcJmInfoList(hj);
        if(szxcJmInfos!=null&&szxcJmInfos.size()>0){
            return AjaxResult.error("身份证号已存在");
        }
        szxcJmInfo.setUpdateTime(DateUtils.getNowDate());
        int result = szxcJmInfoMapper.updateSzxcJmInfo(szxcJmInfo);
        if(result>0){
            return AjaxResult.success();
        }
        return AjaxResult.error();
    }

    /**
     * 批量删除居民信息
     * 
     * @param ids 需要删除的居民信息主键
     * @return 结果
     */
    @Override
    public int deleteSzxcJmInfoByIds(Long[] ids)
    {
        return szxcJmInfoMapper.deleteSzxcJmInfoByIds(ids);
    }

    /**
     * 删除居民信息信息
     * 
     * @param id 居民信息主键
     * @return 结果
     */
    @Override
    public int deleteSzxcJmInfoById(Long id)
    {
        return szxcJmInfoMapper.deleteSzxcJmInfoById(id);
    }

    @Override
    public List<Map<String, Object>> getDataByTag() {
        return szxcJmInfoMapper.getDataByTag();
    }

    @Override
    public List<Map<String, Object>> getDataBySex() {
        return szxcJmInfoMapper.getDataBySex();
    }
    @Override
    public List<Map<String, Object>> getDataByAge() {
        return szxcJmInfoMapper.getDataByAge();
    }
}
